{ Quellen:
  https://www.getlazarus.org/forums/viewtopic.php?t=52
  und

}

unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DBGrids, ComCtrls, ZConnection, ZDataset;

type
  { TForm1 }
  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    EditSQLStatement: TEdit;
    LabelSQLStatement: TLabel;
    StatusBar1: TStatusBar;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Note that it's not important the form know what type of threads are being used }
    FThread,
    FTimerThread: TThread;
  public

  end;

var
  Form1: TForm1;
  //MyCS : TRTLCriticalSection;

implementation

{$R *.lfm}

{ TTimerThread }

type
  TTimerThread = class(TThread)
  private
    FForm:       TForm1;
    fStatusText: string;
    procedure ShowStatus;
  protected
    procedure Execute; override;
  public
    //constructor Create(CreateSuspended: boolean);
    constructor Create(Form: TForm1);
  end;

procedure TTimerThread.ShowStatus;
// this method is only called by Synchronize(@ShowStatus) and therefore
// executed by the main thread
// The main thread can access GUI elements, for example Form1.Caption.
begin
  //FForm.Caption := fStatusText;
end;

procedure TTimerThread.Execute;
var
  newStatus: string;
  starttime: TDatetime;
begin
  starttime := Now;
  //fStatusText := 'TMyThread Starting ...';
  Synchronize(@Showstatus);
  //fStatusText := 'TMyThread Running ...';
  //while (not Terminated) and (true {any condition required}) do
  while (not Terminated) do
  begin
    //here goes the code of the main thread loop
    newStatus := 'SQL-Thread                        Elapsed time: '+ FormatDateTime('HH:NN:SS',Now-starttime);
    sleep(250);
    if NewStatus <> fStatusText then
    begin
      fStatusText := newStatus;
      Synchronize(@Showstatus);
    end;
  end;
  Synchronize(@Showstatus);
end;

//constructor TTimerThread.Create(CreateSuspended: boolean);
constructor TTimerThread.Create(Form: TForm1);
begin
  { Store a copy of which form instance we are associated }
  FForm := Form;
  FreeOnTerminate := True;
  //inherited Create(CreateSuspended);
  { DO NOT start running right away }
  inherited Create(true);
end;

{ TSQLThread }

type
  TSQLThread = class(TThread)
  private
    { Store a reference to a form here }
    FForm:      TForm1;
    FStopped:   boolean;
    FStartTime: TDateTime;
    { You could optionally store your dataset here }
    { FQuery: TQuery }
    { Complete is synchronized with the main user interface thread }
    procedure Completed;
    procedure Canceled;
  protected
    { Execute runs in a background thread }
    procedure Execute; override;
  public
    { Execute runs in a background thread }
    constructor Create(Form: TForm1);
  end;

constructor TSQLThread.Create(Form: TForm1);
begin
  { Store a copy of which form instance we are associated }
  FForm := Form;
  { It is still safe to modify user interface elements here }
  FForm.StatusBar1.SimpleText := 'Thread is running...';
  FStopped := false;
  { Start running right away }
  inherited Create(False);
end;

procedure TSQLThread.Canceled;
begin
  { By settings form thread variable to nil we signal we are stopped }
  FForm.FThread := nil;
  { Do other work here on stop where we might need to touch the user interface. }
  FForm.DBGrid1.Clear;
  FForm.ZConnection1.Connected := false;
  FForm.ZConnection1.Connected := true;
  FForm.StatusBar1.SimpleText := 'Thread was canceled! Time: ' + FormatDateTime('HH:NN:SS', Now - FStartTime);
  //FForm.FTimerThread.Terminate;
  FForm.Button1.Caption := 'Start';
  Application.ProcessMessages;
end;

procedure TSQLThread.Completed;
begin
  { By settings form thread variable to nil we signal we are done }
  FForm.FThread := nil;
  //FForm.FTimerThread.Terminate;
  { If you need to update user interface elements like a grid, do it here }
  FForm.StatusBar1.SimpleText := 'Thread was completed. Time: ' + FormatDateTime('HH:NN:SS', Now - FStartTime);
  { You could connect the result of FQuery to a grid here }
  FForm.DBGrid1.AutoAdjustColumns;
  FForm.Button1.Caption := 'Start';
  Application.ProcessMessages;
end;

procedure TSQLThread.Execute;
begin
  { Free the thread when it completes }
  FreeOnTerminate := True;
  { Do your work here, which may include database activity.
    We simulate some work here by issuing a sleep for 10 seconds command. }
  FStartTime := Now;
  try
    if FForm.ZConnection1.Ping then
    begin
      //EnterCriticalSection(MyCS);
      //try
        FForm.ZQuery1.SQL.Clear;
        FForm.ZQuery1.SQL.Text := FForm.EditSQLStatement.Text;
        FForm.ZQuery1.Open;
      //finally
      //  LeaveCriticalSection(MyCS);
      //end;

      { You could use FQuery here }
      { Then we signal the main user interface we are done }
      Synchronize(@Completed);
    end;
  except
    on E: Exception do
    begin
      //uncomment for Linux
      //writeln(E.Message);
      //only for debugging
      //FForm.StatusBar1.SimpleText := E.Message;
      //sleep(2000);
      Synchronize(@Canceled);
    end;
  end;
end;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  //ZQuery1.DisableControls;
  { If work in a thread hasn't been started yet then start it here }
  if FThread = nil then
  begin
    FThread := TSQLThread.Create(Self);
    Button1.Caption := 'Stop';
    //FTimerThread := TTimerThread.Create(true); // With the True parameter it doesn't start automatically
    //FTimerThread := TTimerThread.Create(Self);
    //if Assigned(FTimerThread.FatalException) then
    //  raise FTimerThread.FatalException;
    // Here the code initialises anything required before the threads starts executing
    //FTimerThread.Start;
  end
  else
  begin
    ZQuery1.SQL.Clear;
    ZQuery1.SQL.Text := 'DELETE FROM MON$STATEMENTS WHERE MON$STATE = 2';
    ZQuery1.ExecSQL;
    Button1.Caption := 'Start';
  end;
  //ZQuery1.EnableControls;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  { Dont allow the form to close if there is still ongoing work in a thread }
  if FThread <> nil then
  begin
    { This stops the form from being closed and destroyed }
    CanClose := False;
    { Tell the user we're still doing some work and wait for it to complete before closing }
    ShowMessage('Cannot close while work is being performed');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ZConnection1.Connected   := false;
  ZConnection1.Protocol    := 'firebird-3.0';
  ZConnection1.Database    := 'DATABASE.FDB';
  ZConnection1.User        := 'SYSDBA';
  ZConnection1.Password    := 'masterkey';
  ZConnection1.HostName    := 'localhost';
  ZConnection1.Port        := 3050;
  ZConnection1.Connected   := true;
  DataSource1.DataSet      := ZQuery1;
  DBGrid1.DataSource       := DataSource1;
  ZQuery1.Connection       := ZConnection1;
end;

end.

